> ## Documentation Index
> Fetch the complete documentation index at: https://docs.voiceflow.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Search documents

> Find all documents that match the specified criteria.



## OpenAPI

````yaml /specs/realtime/openapi.public.json get /v1alpha1/public/knowledge-base/document
openapi: 3.0.0
info:
  title: Realtime
  description: Realtime gateway API service
  version: 1.0.0
  contact: {}
servers:
  - url: https://realtime-api.voiceflow.com
security: []
paths:
  /v1alpha1/public/knowledge-base/document:
    get:
      tags:
        - KBPublicApiDocument
        - Public-Docs
      summary: Search documents
      description: Find all documents that match the specified criteria.
      operationId: KnowledgeBaseDocumentApiPublicHTTPController_getMany
      parameters:
        - name: page
          required: false
          in: query
          schema:
            description: >-
              The page number to retrieve, defaults to 1 (which is the minimum).
              Order is by the date updated, descending.
            type: string
        - name: limit
          required: false
          in: query
          schema:
            description: >-
              The number of documents to return per page. Defaults to 10, range
              is 1-100.
            type: string
        - name: documentType
          required: false
          in: query
          schema:
            description: >-
              Filters the document list by type (url, pdf, text, docx). Defaults
              to all document types.
            allOf:
              - $ref: '#/components/schemas/KnowledgeBaseDocumentType'
        - name: projectEnvironmentIDOrAlias
          required: false
          in: query
          schema:
            description: >-
              The alias of the environment to target (ie. `main`). You can find
              this in the environments page of your agent.


              > **💡 Tip:** [Learn more about
              Environments](/documentation/deploy/environments).
            type: string
      responses:
        '200':
          description: Documents matching the specified criteria.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/DocumentFindManyPublicResponse'
      security:
        - auth: []
components:
  schemas:
    KnowledgeBaseDocumentType:
      type: string
      enum:
        - csv
        - pdf
        - text
        - url
        - docx
        - table
        - xlsx
        - md
      x-enumNames:
        - CSV
        - PDF
        - TEXT
        - URL
        - DOCX
        - TABLE
        - XLSX
        - MD
    DocumentFindManyPublicResponse:
      type: object
      properties:
        total:
          type: number
        data:
          type: array
          items:
            type: object
            properties:
              documentID:
                type: string
              data:
                nullable: true
                allOf:
                  - $ref: '#/components/schemas/KBDocumentData'
              updatedAt:
                type: string
                format: date-time
                pattern: >-
                  ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
              status:
                $ref: '#/components/schemas/KBDocumentStatus'
            required:
              - documentID
              - data
              - updatedAt
              - status
      required:
        - total
        - data
    KBDocumentData:
      oneOf:
        - $ref: '#/components/schemas/KBDocumentUrlData'
        - $ref: '#/components/schemas/KBDocumentDocxData'
        - $ref: '#/components/schemas/KBDocumentPDFData'
        - $ref: '#/components/schemas/KBDocumentTextData'
        - $ref: '#/components/schemas/KBDocumentMarkdownData'
        - $ref: '#/components/schemas/KBDocumentCSVData'
        - $ref: '#/components/schemas/KBDocumentXLSXData'
        - $ref: '#/components/schemas/KBDocumentTableData'
    KBDocumentStatus:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/KnowledgeBaseDocumentStatus'
        data: {}
      required:
        - type
    KBDocumentUrlData:
      type: object
      properties:
        type:
          type: string
          enum:
            - url
          x-enumNames:
            - URL
        name:
          type: string
        url:
          type: string
        refreshRate:
          allOf:
            - $ref: '#/components/schemas/KnowledgeBaseDocumentRefreshRate'
        lastSuccessUpdate:
          type: string
        accessTokenID:
          type: number
        integrationExternalID:
          type: string
        source:
          allOf:
            - $ref: '#/components/schemas/KnowledgeBaseDocumentIntegrationType'
      required:
        - type
        - name
        - url
    KBDocumentDocxData:
      type: object
      properties:
        type:
          type: string
          enum:
            - docx
          x-enumNames:
            - DOCX
        name:
          type: string
        url:
          nullable: true
          type: string
      required:
        - type
        - name
    KBDocumentPDFData:
      type: object
      properties:
        type:
          type: string
          enum:
            - pdf
          x-enumNames:
            - PDF
        name:
          type: string
        url:
          nullable: true
          type: string
      required:
        - type
        - name
    KBDocumentTextData:
      type: object
      properties:
        type:
          type: string
          enum:
            - text
          x-enumNames:
            - TEXT
        name:
          type: string
        canEdit:
          type: boolean
        url:
          nullable: true
          type: string
      required:
        - type
        - name
    KBDocumentMarkdownData:
      type: object
      properties:
        type:
          type: string
          enum:
            - md
          x-enumNames:
            - MD
        name:
          type: string
        url:
          nullable: true
          type: string
      required:
        - type
        - name
    KBDocumentCSVData:
      type: object
      properties:
        type:
          type: string
          enum:
            - csv
          x-enumNames:
            - CSV
        name:
          type: string
        rowsCount:
          type: number
        url:
          nullable: true
          type: string
      required:
        - type
        - name
    KBDocumentXLSXData:
      type: object
      properties:
        type:
          type: string
          enum:
            - xlsx
          x-enumNames:
            - XLSX
        name:
          type: string
        rowsCount:
          type: number
        url:
          nullable: true
          type: string
      required:
        - type
        - name
    KBDocumentTableData:
      type: object
      properties:
        type:
          type: string
          enum:
            - table
          x-enumNames:
            - TABLE
        name:
          type: string
        rowsCount:
          type: number
        url:
          nullable: true
          type: string
      required:
        - type
        - name
        - rowsCount
    KnowledgeBaseDocumentStatus:
      type: string
      enum:
        - ERROR
        - PENDING
        - SUCCESS
        - INITIALIZED
      x-enumNames:
        - ERROR
        - PENDING
        - SUCCESS
        - INITIALIZED
    KnowledgeBaseDocumentRefreshRate:
      type: string
      enum:
        - daily
        - weekly
        - monthly
        - never
      x-enumNames:
        - DAILY
        - WEEKLY
        - MONTHLY
        - NEVER
    KnowledgeBaseDocumentIntegrationType:
      type: string
      enum:
        - zendesk
        - shopify
      x-enumNames:
        - ZENDESK
        - SHOPIFY
  securitySchemes:
    auth:
      type: apiKey
      in: header
      name: authorization
      description: Voiceflow API key

````